/*************************************
 *        Global Simulator           *
 *************************************/

package CHARON.simulator;
import CHARON.gui.manager.*;
import CHARON.simulator.*;
import CHARON.simulator.classes.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import CHARON.user.*;


public class CoffeeMachine1rTest {
 
  private static TestProgressDiag testProgressDiag; 


  public static void setTestProgressDiag(TestProgressDiag instance) { 
    testProgressDiag=instance;
  }
  public static void main(String argv[]) {
    String s = null;
    boolean pauseBeforeTransition = false;
    int maxSimStep = 100;
    byte displayMode = Simulation.displayAllVarStep;
    boolean allowModeSelection = true;
    PrintWriter file = null;
    int ams = 1;
    double  tempD= 1.0;

    Element.clearAll();

    double  duration= 0.001;

    String  stopProperty= "null";

    String fileName = "CoffeeMachine1gTest.rep";

    RandomTest randomTest=new CoffeeMachine1RandomTest();
    Vector agents =  new Vector();
    Vector paramVector1 =  new Vector();
    HashMap renaming = new HashMap();
    CHARONSystem system$ = new CHARONSystem(5);

    /* Root Composite Agent: CoffeeMachine1 */
    CompositeAgent RootCoffeeMachine1 = new CompositeAgent(randomTest);

    system$.numCreatedAgents ++;
    RootCoffeeMachine1.setAgentName("CoffeeMachine1");


    /* Hidden Variable */
    Bool ack_coffee_on = new Bool("private", null, "discrete",  "ack_coffee_on");
    ack_coffee_on.shared = true;
    ack_coffee_on.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_coffee_on);
    RootCoffeeMachine1.putPrivateVar(ack_coffee_on);

    Bool ack_money_inc = new Bool("private", null, "discrete",  "ack_money_inc");
    ack_money_inc.shared = true;
    ack_money_inc.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_money_inc);
    RootCoffeeMachine1.putPrivateVar(ack_money_inc);

    Bool ack_money_off = new Bool("private", null, "discrete",  "ack_money_off");
    ack_money_off.shared = true;
    ack_money_off.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_money_off);
    RootCoffeeMachine1.putPrivateVar(ack_money_off);

    Bool ack_coffee_done = new Bool("private", null, "discrete",  "ack_coffee_done");
    ack_coffee_done.shared = true;
    ack_coffee_done.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_coffee_done);
    RootCoffeeMachine1.putPrivateVar(ack_coffee_done);

    Bool ack_coffee_coffee = new Bool("private", null, "discrete",  "ack_coffee_coffee");
    ack_coffee_coffee.shared = true;
    ack_coffee_coffee.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_coffee_coffee);
    RootCoffeeMachine1.putPrivateVar(ack_coffee_coffee);

    Bool done = new Bool("private", null, "discrete",  "done");
    done.shared = true;
    done.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(done);
    RootCoffeeMachine1.putPrivateVar(done);

    Bool inc = new Bool("private", null, "discrete",  "inc");
    inc.shared = true;
    inc.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(inc);
    RootCoffeeMachine1.putPrivateVar(inc);

    Bool coffee = new Bool("private", null, "discrete",  "coffee");
    coffee.shared = true;
    coffee.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(coffee);
    RootCoffeeMachine1.putPrivateVar(coffee);

    Bool ack_coffee_inc = new Bool("private", null, "discrete",  "ack_coffee_inc");
    ack_coffee_inc.shared = true;
    ack_coffee_inc.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_coffee_inc);
    RootCoffeeMachine1.putPrivateVar(ack_coffee_inc);

    Bool poweroff = new Bool("private", null, "discrete",  "poweroff");
    poweroff.shared = true;
    poweroff.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(poweroff);
    RootCoffeeMachine1.putPrivateVar(poweroff);

    Bool ack_coffee_off = new Bool("private", null, "discrete",  "ack_coffee_off");
    ack_coffee_off.shared = true;
    ack_coffee_off.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_coffee_off);
    RootCoffeeMachine1.putPrivateVar(ack_coffee_off);

    Bool ack_money_coffee = new Bool("private", null, "discrete",  "ack_money_coffee");
    ack_money_coffee.shared = true;
    ack_money_coffee.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_money_coffee);
    RootCoffeeMachine1.putPrivateVar(ack_money_coffee);

    Bool ack_money_on = new Bool("private", null, "discrete",  "ack_money_on");
    ack_money_on.shared = true;
    ack_money_on.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_money_on);
    RootCoffeeMachine1.putPrivateVar(ack_money_on);

    Int priority = new Int("private", null, "discrete",  "priority");
    priority.shared = true;
    priority.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(priority);
    RootCoffeeMachine1.putPrivateVar(priority);

    Bool poweron = new Bool("private", null, "discrete",  "poweron");
    poweron.shared = true;
    poweron.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(poweron);
    RootCoffeeMachine1.putPrivateVar(poweron);

    Bool ack_money_done = new Bool("private", null, "discrete",  "ack_money_done");
    ack_money_done.shared = true;
    ack_money_done.controllable = true;
    RootCoffeeMachine1.putDiscreteVar(ack_money_done);
    RootCoffeeMachine1.putPrivateVar(ack_money_done);


    /* environment */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.AEnvironment environment = new CHARON.simulator.agents.AEnvironment(randomTest, renaming, paramVector1, RootCoffeeMachine1.getAnalogVars(), RootCoffeeMachine1.getDiscreteVars(), RootCoffeeMachine1.getAssertions(), "environment", system$, RootCoffeeMachine1);

    system$.numCreatedAgents ++;
    agents.addElement(environment);
    RootCoffeeMachine1.putSubagent(environment);

    /* realmachine */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.ARealmachine realmachine = new CHARON.simulator.agents.ARealmachine(randomTest, renaming, paramVector1, RootCoffeeMachine1.getAnalogVars(), RootCoffeeMachine1.getDiscreteVars(), RootCoffeeMachine1.getAssertions(), "realmachine", system$, RootCoffeeMachine1);

    system$.numCreatedAgents ++;
    agents.addElement(realmachine);

    agents = realmachine.addInstantiatedSubagent(agents);
    RootCoffeeMachine1.putSubagent(realmachine);

    agents.addElement(RootCoffeeMachine1);
    system$.doneCreatingAgents = true;



    if(argv.length == 1) {
      maxSimStep = Integer.parseInt(argv[0]);
    }

    else if(argv.length == 2) {
      maxSimStep = Integer.parseInt(argv[0]);
      duration = Double.parseDouble(argv[1]);
    }

    else if(argv.length >= 3) {
      maxSimStep = Integer.parseInt(argv[0]);
      duration = Double.parseDouble(argv[1]);
      stopProperty = argv[2];
    }

    testProgressDiag.setTotalModes(randomTest.getTotalModes()); // Show total number of modes. -tanli
    testProgressDiag.setTotalNonAtomicAgents(randomTest.getTotalNonAgents()); // Show total number of non-atomic agents. -tanli
    testProgressDiag.setTotalAtomicAgents(randomTest.getTotalAgents()-randomTest.getTotalNonAgents()); // Show total number of atomic agents. -tanli
    testProgressDiag.setTotalAgents(randomTest.getTotalAgents()); // Show total number of agents. -tanli
    testProgressDiag.setTotalTrans(randomTest.getTotalTrans()); // Show total number of transitions. -tanli 

        testProgressDiag.startTimer();

        randomTest.charonPM = testProgressDiag.charonPM;

        if (Simulation.isEnabledModeCoverage()){
            RandomTest.coverageCriteria = RandomTest.MODECOVERAGE;
        }
        else {
            RandomTest.coverageCriteria = RandomTest.TRANSCOVERAGE;
        }

    randomTest.setTestProgressDiag(testProgressDiag); // Set the dialog box handler -tanli
    testProgressDiag.setRandomTestHandler(randomTest); // Set the handler of thread so stop button on dialog box can terminate the thread -tanli

  randomTest.run(maxSimStep, displayMode, allowModeSelection, agents, pauseBeforeTransition, fileName, system$, duration, stopProperty);
    randomTest.setTestProgressDiag(null); // Reset the handler of dialog box. -tanli
  }
} // class rTest


/*************************************
 *  CoffeeMachine1Test: extending simulator class
 *************************************/

class CoffeeMachine1RandomTest extends RandomTest {

  public CoffeeMachine1RandomTest() {
    super();
  }

  void processTransition(Transition t, int eId) {

    testProgressDiag.updateTimer();

    Mode dst = null;
    if (t.isToChoicePoint()) {
      for (int i = 0; i < t.getChoices().size(); i++)
        if (((GuardedActionChoice) t.getChoices().elementAt(i)).getGuardId() == eId) {
          aName = ((GuardedActionChoice) t.getChoices().elementAt(i)).getAction().getClass().getName();
          dst = ((GuardedActionChoice) t.getChoices().elementAt(i)).getDstMode();
        }
    }
    else{
      aName = ((Action) t.getAction()).getClass().getName();
      dst = t.getDstMode();
    }
    if (pauseBeforeTransition) {
      System.out.println("Press Enter/Return Key!");
      pause();
    }
    if (aName.equals("CHARON.simulator.modes.Coffee$Action0")) 
      ((CHARON.simulator.modes.Coffee.Action0) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action1")) 
      ((CHARON.simulator.modes.Coffee.Action1) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action2")) 
      ((CHARON.simulator.modes.Coffee.Action2) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action3")) 
      ((CHARON.simulator.modes.Coffee.Action3) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action4")) 
      ((CHARON.simulator.modes.Coffee.Action4) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action5")) 
      ((CHARON.simulator.modes.Coffee.Action5) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action6")) 
      ((CHARON.simulator.modes.Coffee.Action6) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action7")) 
      ((CHARON.simulator.modes.Coffee.Action7) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action8")) 
      ((CHARON.simulator.modes.Coffee.Action8) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action9")) 
      ((CHARON.simulator.modes.Coffee.Action9) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action10")) 
      ((CHARON.simulator.modes.Coffee.Action10) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action11")) 
      ((CHARON.simulator.modes.Coffee.Action11) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action12")) 
      ((CHARON.simulator.modes.Coffee.Action12) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action13")) 
      ((CHARON.simulator.modes.Coffee.Action13) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action14")) 
      ((CHARON.simulator.modes.Coffee.Action14) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action15")) 
      ((CHARON.simulator.modes.Coffee.Action15) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action16")) 
      ((CHARON.simulator.modes.Coffee.Action16) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action17")) 
      ((CHARON.simulator.modes.Coffee.Action17) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action18")) 
      ((CHARON.simulator.modes.Coffee.Action18) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action19")) 
      ((CHARON.simulator.modes.Coffee.Action19) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action20")) 
      ((CHARON.simulator.modes.Coffee.Action20) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action21")) 
      ((CHARON.simulator.modes.Environment.Action21) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action22")) 
      ((CHARON.simulator.modes.Environment.Action22) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action23")) 
      ((CHARON.simulator.modes.Environment.Action23) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action24")) 
      ((CHARON.simulator.modes.Environment.Action24) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action25")) 
      ((CHARON.simulator.modes.Environment.Action25) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action26")) 
      ((CHARON.simulator.modes.Environment.Action26) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action27")) 
      ((CHARON.simulator.modes.Environment.Action27) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action28")) 
      ((CHARON.simulator.modes.Environment.Action28) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action29")) 
      ((CHARON.simulator.modes.Environment.Action29) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action30")) 
      ((CHARON.simulator.modes.Environment.Action30) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action31")) 
      ((CHARON.simulator.modes.Environment.Action31) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action32")) 
      ((CHARON.simulator.modes.Money.Action32) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action33")) 
      ((CHARON.simulator.modes.Money.Action33) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action34")) 
      ((CHARON.simulator.modes.Money.Action34) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action35")) 
      ((CHARON.simulator.modes.Money.Action35) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action36")) 
      ((CHARON.simulator.modes.Money.Action36) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action37")) 
      ((CHARON.simulator.modes.Money.Action37) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action38")) 
      ((CHARON.simulator.modes.Money.Action38) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action39")) 
      ((CHARON.simulator.modes.Money.Action39) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action40")) 
      ((CHARON.simulator.modes.Money.Action40) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action41")) 
      ((CHARON.simulator.modes.Money.Action41) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action42")) 
      ((CHARON.simulator.modes.Money.Action42) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action43")) 
      ((CHARON.simulator.modes.Money.Action43) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action44")) 
      ((CHARON.simulator.modes.Money.Action44) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action45")) 
      ((CHARON.simulator.modes.Money.Action45) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action46")) 
      ((CHARON.simulator.modes.Money.Action46) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action47")) 
      ((CHARON.simulator.modes.Money.Action47) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action48")) 
      ((CHARON.simulator.modes.Money.Action48) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action49")) 
      ((CHARON.simulator.modes.Money.Action49) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action50")) 
      ((CHARON.simulator.modes.Money.Action50) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action51")) 
      ((CHARON.simulator.modes.Money.Action51) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action52")) 
      ((CHARON.simulator.modes.Money.Action52) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action53")) 
      ((CHARON.simulator.modes.Money.Action53) t.getAction()).action();
    sas.clearGuards();
    sas.clearTransitions();
    sas.clearInvariants();
    sas.clearAlgeEqns();
    sas.clearAssertions();
    sas.clearDiffEqns();
    sas.clearDiscreteVars();
    sas.clearAnalogVars();

    Mode p = dst;
    while (p != null) {
      sas.putTransitions(p.getTransitions(), t, eId);
      sas.putInvariant(p.getInvariant());
      sas.putAlgeEqns(p.getAlgeEqns());
      sas.putAssertions(p.getAssertions());
      sas.putDiffEqns(p.getDiffEqns());
      sas.putDiscreteVars(p.getDiscreteVars());
      sas.putAnalogVars(p.getAnalogVars());

      p = p.getParent();
    }

    sas.setConfiguration(dst.pathname);

    if (this.coverAction(t.getAction())){
    this.testProgressDiag.setActionsCovered(this.getCoveredActions()); // tanli
    if (this.coverageCriteria==this.ACTIONCOVERAGE) {
        System.out.println("Need to log this run");
        needLog=true;
    }
   }
   boolean srcModeNotCoveredBefore=this.coverMode(t.getSrcMode()); // tanli
   boolean dstModeNotCoveredBefore=this.coverMode(dst); // tanli
   if (srcModeNotCoveredBefore||dstModeNotCoveredBefore){ // tanli
      ((TestProgressDiag) this.testProgressDiag).setModeCovered(this.getCoveredModes()); // tanli
      this.testProgressDiag.setProgressBarModeCovered(this.getCoveredModes()*100/this.getTotalModes()); // tanli
      System.out.println("Should cover this run");
      if (this.coverageCriteria==this.MODECOVERAGE) {
      System.out.println("Need to log this run");
      needLog=true;
      }
    };
   if (this.coverTrans(t)){ // tanli
      ((TestProgressDiag) this.testProgressDiag).setTransCovered(this.getCoveredTrans()); // tanli
      this.testProgressDiag.setProgressBarTransCovered(this.getCoveredTrans()*100/this.getTotalTrans()); // tanli
      if (this.coverageCriteria==this.TRANSCOVERAGE) {
        System.out.println("Need to log this run");
        needLog=true;
      }
    };
  } // end ProcessTransition
} // end CoffeeMachine1Simulation class
