/*************************************
 *        Global Simulator           *
 *************************************/

package CHARON.simulator;
import CHARON.simulator.classes.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import CHARON.user.*;


public class CoffeeMachinegSim {
  public static void main(String argv[]) {
    String s = null;
    boolean pauseBeforeTransition = false;
    int maxSimStep = 100;
    byte displayMode = Simulation.displayAllVarStep;
    boolean allowModeSelection = true;
    PrintWriter file = null;
    int ams = 1;
    double  tempD= 1.0;

    double  duration= 0.001;

    String  stopProperty= "null";

    String fileName = "CoffeeMachinegSim.rep";

    Vector agents =  new Vector();
    Vector paramVector1 =  new Vector();
    HashMap renaming = new HashMap();
    CHARONSystem system$ = new CHARONSystem(5);

    /* Root Composite Agent: CoffeeMachine */
    CompositeAgent RootCoffeeMachine = new CompositeAgent();

    system$.numCreatedAgents ++;
    RootCoffeeMachine.setAgentName("CoffeeMachine");


    /* Hidden Variable */
    Bool ack_coffee_on = new Bool("private", null, "discrete",  "ack_coffee_on");
    ack_coffee_on.shared = true;
    ack_coffee_on.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_coffee_on);
    RootCoffeeMachine.putPrivateVar(ack_coffee_on);

    Bool ack_money_inc = new Bool("private", null, "discrete",  "ack_money_inc");
    ack_money_inc.shared = true;
    ack_money_inc.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_money_inc);
    RootCoffeeMachine.putPrivateVar(ack_money_inc);

    Bool ack_money_off = new Bool("private", null, "discrete",  "ack_money_off");
    ack_money_off.shared = true;
    ack_money_off.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_money_off);
    RootCoffeeMachine.putPrivateVar(ack_money_off);

    Bool ack_coffee_done = new Bool("private", null, "discrete",  "ack_coffee_done");
    ack_coffee_done.shared = true;
    ack_coffee_done.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_coffee_done);
    RootCoffeeMachine.putPrivateVar(ack_coffee_done);

    Bool ack_coffee_coffee = new Bool("private", null, "discrete",  "ack_coffee_coffee");
    ack_coffee_coffee.shared = true;
    ack_coffee_coffee.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_coffee_coffee);
    RootCoffeeMachine.putPrivateVar(ack_coffee_coffee);

    Bool done = new Bool("private", null, "discrete",  "done");
    done.shared = true;
    done.controllable = true;
    RootCoffeeMachine.putDiscreteVar(done);
    RootCoffeeMachine.putPrivateVar(done);

    Bool inc = new Bool("private", null, "discrete",  "inc");
    inc.shared = true;
    inc.controllable = true;
    RootCoffeeMachine.putDiscreteVar(inc);
    RootCoffeeMachine.putPrivateVar(inc);

    Bool coffee = new Bool("private", null, "discrete",  "coffee");
    coffee.shared = true;
    coffee.controllable = true;
    RootCoffeeMachine.putDiscreteVar(coffee);
    RootCoffeeMachine.putPrivateVar(coffee);

    Bool ack_coffee_inc = new Bool("private", null, "discrete",  "ack_coffee_inc");
    ack_coffee_inc.shared = true;
    ack_coffee_inc.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_coffee_inc);
    RootCoffeeMachine.putPrivateVar(ack_coffee_inc);

    Bool poweroff = new Bool("private", null, "discrete",  "poweroff");
    poweroff.shared = true;
    poweroff.controllable = true;
    RootCoffeeMachine.putDiscreteVar(poweroff);
    RootCoffeeMachine.putPrivateVar(poweroff);

    Bool ack_coffee_off = new Bool("private", null, "discrete",  "ack_coffee_off");
    ack_coffee_off.shared = true;
    ack_coffee_off.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_coffee_off);
    RootCoffeeMachine.putPrivateVar(ack_coffee_off);

    Bool ack_money_coffee = new Bool("private", null, "discrete",  "ack_money_coffee");
    ack_money_coffee.shared = true;
    ack_money_coffee.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_money_coffee);
    RootCoffeeMachine.putPrivateVar(ack_money_coffee);

    Bool ack_money_on = new Bool("private", null, "discrete",  "ack_money_on");
    ack_money_on.shared = true;
    ack_money_on.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_money_on);
    RootCoffeeMachine.putPrivateVar(ack_money_on);

    Int priority = new Int("private", null, "discrete",  "priority");
    priority.shared = true;
    priority.controllable = true;
    RootCoffeeMachine.putDiscreteVar(priority);
    RootCoffeeMachine.putPrivateVar(priority);

    Bool poweron = new Bool("private", null, "discrete",  "poweron");
    poweron.shared = true;
    poweron.controllable = true;
    RootCoffeeMachine.putDiscreteVar(poweron);
    RootCoffeeMachine.putPrivateVar(poweron);

    Bool ack_money_done = new Bool("private", null, "discrete",  "ack_money_done");
    ack_money_done.shared = true;
    ack_money_done.controllable = true;
    RootCoffeeMachine.putDiscreteVar(ack_money_done);
    RootCoffeeMachine.putPrivateVar(ack_money_done);


    /* environment */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.AEnvironment environment = new CHARON.simulator.agents.AEnvironment(renaming, paramVector1, RootCoffeeMachine.getAnalogVars(), RootCoffeeMachine.getDiscreteVars(), RootCoffeeMachine.getAssertions(), "environment", system$, RootCoffeeMachine);

    system$.numCreatedAgents ++;
    agents.addElement(environment);
    RootCoffeeMachine.putSubagent(environment);

    /* realmachine */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.ARealmachine realmachine = new CHARON.simulator.agents.ARealmachine(renaming, paramVector1, RootCoffeeMachine.getAnalogVars(), RootCoffeeMachine.getDiscreteVars(), RootCoffeeMachine.getAssertions(), "realmachine", system$, RootCoffeeMachine);

    system$.numCreatedAgents ++;
    agents.addElement(realmachine);

    agents = realmachine.addInstantiatedSubagent(agents);
    RootCoffeeMachine.putSubagent(realmachine);

    agents.addElement(RootCoffeeMachine);
    system$.doneCreatingAgents = true;



    if(argv.length == 1) {
      maxSimStep = Integer.parseInt(argv[0]);
    }

    else if(argv.length == 2) {
      maxSimStep = Integer.parseInt(argv[0]);
      duration = Double.parseDouble(argv[1]);
    }

    else if(argv.length >= 3) {
      maxSimStep = Integer.parseInt(argv[0]);
      duration = Double.parseDouble(argv[1]);
      stopProperty = argv[2];
    }


    new CoffeeMachineSimulation().run(maxSimStep, displayMode, allowModeSelection, agents, pauseBeforeTransition, fileName, system$, duration, stopProperty);
  }
} // class gSim


/*************************************
 *  CoffeeMachineSimulation: extending simulator class
 *************************************/

class CoffeeMachineSimulation extends Simulation {

  public CoffeeMachineSimulation() {
    super();
  }

  void processTransition(Transition t, int eId) {

    Mode dst = null;
    if (t.isToChoicePoint()) {
      for (int i = 0; i < t.getChoices().size(); i++)
        if (((GuardedActionChoice) t.getChoices().elementAt(i)).getGuardId() == eId) {
          aName = ((GuardedActionChoice) t.getChoices().elementAt(i)).getAction().getClass().getName();
          dst = ((GuardedActionChoice) t.getChoices().elementAt(i)).getDstMode();
        }
    }
    else{
      aName = ((Action) t.getAction()).getClass().getName();
      dst = t.getDstMode();
    }
    if (pauseBeforeTransition) {
      System.out.println("Press Enter/Return Key!");
      pause();
    }
    if (aName.equals("CHARON.simulator.modes.Coffee$Action0")) 
      ((CHARON.simulator.modes.Coffee.Action0) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action1")) 
      ((CHARON.simulator.modes.Coffee.Action1) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action2")) 
      ((CHARON.simulator.modes.Coffee.Action2) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action3")) 
      ((CHARON.simulator.modes.Coffee.Action3) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action4")) 
      ((CHARON.simulator.modes.Coffee.Action4) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action5")) 
      ((CHARON.simulator.modes.Coffee.Action5) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action6")) 
      ((CHARON.simulator.modes.Coffee.Action6) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action7")) 
      ((CHARON.simulator.modes.Coffee.Action7) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action8")) 
      ((CHARON.simulator.modes.Coffee.Action8) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action9")) 
      ((CHARON.simulator.modes.Coffee.Action9) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action10")) 
      ((CHARON.simulator.modes.Coffee.Action10) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action11")) 
      ((CHARON.simulator.modes.Coffee.Action11) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action12")) 
      ((CHARON.simulator.modes.Coffee.Action12) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action13")) 
      ((CHARON.simulator.modes.Coffee.Action13) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action14")) 
      ((CHARON.simulator.modes.Coffee.Action14) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action15")) 
      ((CHARON.simulator.modes.Coffee.Action15) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action16")) 
      ((CHARON.simulator.modes.Coffee.Action16) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action17")) 
      ((CHARON.simulator.modes.Coffee.Action17) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action18")) 
      ((CHARON.simulator.modes.Coffee.Action18) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action19")) 
      ((CHARON.simulator.modes.Coffee.Action19) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Coffee$Action20")) 
      ((CHARON.simulator.modes.Coffee.Action20) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action21")) 
      ((CHARON.simulator.modes.Environment.Action21) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action22")) 
      ((CHARON.simulator.modes.Environment.Action22) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action23")) 
      ((CHARON.simulator.modes.Environment.Action23) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action24")) 
      ((CHARON.simulator.modes.Environment.Action24) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action25")) 
      ((CHARON.simulator.modes.Environment.Action25) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action26")) 
      ((CHARON.simulator.modes.Environment.Action26) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action27")) 
      ((CHARON.simulator.modes.Environment.Action27) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action28")) 
      ((CHARON.simulator.modes.Environment.Action28) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action29")) 
      ((CHARON.simulator.modes.Environment.Action29) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action30")) 
      ((CHARON.simulator.modes.Environment.Action30) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Environment$Action31")) 
      ((CHARON.simulator.modes.Environment.Action31) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action32")) 
      ((CHARON.simulator.modes.Money.Action32) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action33")) 
      ((CHARON.simulator.modes.Money.Action33) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action34")) 
      ((CHARON.simulator.modes.Money.Action34) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action35")) 
      ((CHARON.simulator.modes.Money.Action35) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action36")) 
      ((CHARON.simulator.modes.Money.Action36) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action37")) 
      ((CHARON.simulator.modes.Money.Action37) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action38")) 
      ((CHARON.simulator.modes.Money.Action38) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action39")) 
      ((CHARON.simulator.modes.Money.Action39) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action40")) 
      ((CHARON.simulator.modes.Money.Action40) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action41")) 
      ((CHARON.simulator.modes.Money.Action41) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action42")) 
      ((CHARON.simulator.modes.Money.Action42) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action43")) 
      ((CHARON.simulator.modes.Money.Action43) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action44")) 
      ((CHARON.simulator.modes.Money.Action44) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action45")) 
      ((CHARON.simulator.modes.Money.Action45) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action46")) 
      ((CHARON.simulator.modes.Money.Action46) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action47")) 
      ((CHARON.simulator.modes.Money.Action47) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action48")) 
      ((CHARON.simulator.modes.Money.Action48) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action49")) 
      ((CHARON.simulator.modes.Money.Action49) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action50")) 
      ((CHARON.simulator.modes.Money.Action50) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action51")) 
      ((CHARON.simulator.modes.Money.Action51) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action52")) 
      ((CHARON.simulator.modes.Money.Action52) t.getAction()).action();
    if (aName.equals("CHARON.simulator.modes.Money$Action53")) 
      ((CHARON.simulator.modes.Money.Action53) t.getAction()).action();
    sas.clearGuards();
    sas.clearTransitions();
    sas.clearInvariants();
    sas.clearAlgeEqns();
    sas.clearAssertions();
    sas.clearDiffEqns();
    sas.clearDiscreteVars();
    sas.clearAnalogVars();

    Mode p = dst;
    while (p != null) {
      sas.putTransitions(p.getTransitions(), t, eId);
      sas.putInvariant(p.getInvariant());
      sas.putAlgeEqns(p.getAlgeEqns());
      sas.putAssertions(p.getAssertions());
      sas.putDiffEqns(p.getDiffEqns());
      sas.putDiscreteVars(p.getDiscreteVars());
      sas.putAnalogVars(p.getAnalogVars());

      p = p.getParent();
    }

    sas.setConfiguration(dst.pathname);

  } // end ProcessTransition
} // end CoffeeMachineSimulation class
