package CHARON.simulator.agents;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.classes.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import CHARON.user.*;

public class ARealmachine extends CompositeAgent {
	public Int m;
	public Bool dec;

    public ARealmachine(HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
      this(null, rVars, paramOfThisAgent, analogVarOfThisAgent, discreteVarOfThisAgent, vectorOfAssertions, name, sys, agentParent);
}

  public ARealmachine(Simulation sim, HashMap rVars, Vector paramOfThisAgent, Vector analogVarOfThisAgent, Vector discreteVarOfThisAgent, Vector vectorOfAssertions, String name, CHARONSystem sys, Agent agentParent) {
    super(sim);
    system = sys;
    setParent(agentParent);
    setAgentName(name);
    newNames = rVars;
    setAgentParams(paramOfThisAgent);
    pathname = getPathName();
    setDiscreteVars(discreteVarOfThisAgent);
    setAnalogVars(analogVarOfThisAgent);
    setAssertions(vectorOfAssertions);
    Vector paramVector1 =  new Vector();
    HashMap renaming = new HashMap();


    /* Hidden Variable */
    m = new Int("private", null, "discrete",  (getNewName("m") != null) ? getNewName("m"): pathname+"m");
    m.shared = true;
    m.controllable = true;
    putPrivateVar(m);
    putDiscreteVar(m);
    dec = new Bool("private", null, "discrete",  (getNewName("dec") != null) ? getNewName("dec"): pathname+"dec");
    dec.shared = true;
    dec.controllable = true;
    putPrivateVar(dec);
    putDiscreteVar(dec);
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_on"), "Discrete")+getNewName("ack_coffee_on")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_inc"), "Discrete")+getNewName("ack_money_inc")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_done"), "Discrete")+getNewName("ack_coffee_done")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_off"), "Discrete")+getNewName("ack_money_off")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_coffee"), "Discrete")+getNewName("ack_coffee_coffee")));
		putReadVar(getDiscreteVar(getPathName(getNewName("done"), "Discrete")+getNewName("done")));
		putReadVar(getDiscreteVar(getPathName(getNewName("inc"), "Discrete")+getNewName("inc")));
		putReadVar(getDiscreteVar(getPathName(getNewName("coffee"), "Discrete")+getNewName("coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_inc"), "Discrete")+getNewName("ack_coffee_inc")));
		putReadVar(getDiscreteVar(getPathName(getNewName("poweroff"), "Discrete")+getNewName("poweroff")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_coffee_off"), "Discrete")+getNewName("ack_coffee_off")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_coffee"), "Discrete")+getNewName("ack_money_coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_on"), "Discrete")+getNewName("ack_money_on")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("priority"), "Discrete")+getNewName("priority")));
		putReadVar(getDiscreteVar(getPathName(getNewName("poweron"), "Discrete")+getNewName("poweron")));
		putReadWriteVar(getDiscreteVar(getPathName(getNewName("ack_money_done"), "Discrete")+getNewName("ack_money_done")));

    /* coffee */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.ACoffee coffee = new CHARON.simulator.agents.ACoffee(sim, renaming, paramVector1, getAnalogVars(), getDiscreteVars(), getAssertions(), "coffee", system, this);
    this.putSubagent(coffee);

    /* money */
    paramVector1.removeAllElements();
    renaming = new HashMap();
    CHARON.simulator.agents.AMoney money = new CHARON.simulator.agents.AMoney(sim, renaming, paramVector1, getAnalogVars(), getDiscreteVars(), getAssertions(), "money", system, this);
    this.putSubagent(money);
  } // end constructor
} // end ARealmachine
