
package CHARON.simulator.modes;
import CHARON.simulator.classes.*;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import  CHARON.user.*;

public class Coffee extends Mode {
	Mode coffee_off;
	Mode busy;
	Mode idle;

	public Coffee(Simulation sim) {
	  super(sim);
	}

	public Coffee() {
	  this(null);
	}
	public Coffee(String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		this(null, nameOfThisMode, parameterOfThisMode, analogVarOfThisMode, discreteVarOfThisMode, vectorOfAssertions, parentOfThisMode, referredAgentOfThisMode); // tanli
	  }
	public Coffee(Simulation sim, String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		super(sim);
		setModeName(nameOfThisMode);
		setInitSubModeName("coffee_off");
		setParentMode(parentOfThisMode);
		referredAgent = referredAgentOfThisMode;
		pathname = getPathName();
		setDiscreteVars(discreteVarOfThisMode);
		setAnalogVars(analogVarOfThisMode);
		setAssertions(vectorOfAssertions);
		putEntryPoint(new EntryPoint("dE"));
		putExitPoint(new ExitPoint("dX"));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on")));

		/* Parameters */

		/* invariant, diff/alge equation */

		/* Submodes */
		coffee_off = new empty(sim, "coffee_off", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(coffee_off);

		busy = new empty(sim, "busy", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(busy);

		idle = new empty(sim, "idle", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(idle);


		/* Transitions */
		Guard g0 = new Guard(new Guard0());
		putTransition(new Transition(sim, "defToIdle", this, this.getEntryPoint("dE"), idle, idle.getEntryPoint("dE"), g0, new Action0()));
		Guard g1 = new Guard(new Guard1());
		putTransition(new Transition(sim, "defToOff1", this, this.getEntryPoint("dE"), coffee_off, coffee_off.getEntryPoint("dE"), g1, new Action1()));
		Guard g2 = new Guard(new Guard2());
		putTransition(new Transition(sim, "defToOff2", this, this.getEntryPoint("dE"), coffee_off, coffee_off.getEntryPoint("dE"), g2, new Action2()));
		Guard g3 = new Guard(new Guard3());
		putTransition(new Transition(sim, "defToOff3", this, this.getEntryPoint("dE"), coffee_off, coffee_off.getEntryPoint("dE"), g3, new Action3()));
		Guard g4 = new Guard(new Guard4());
		putTransition(new Transition(sim, "defToOff4", this, this.getEntryPoint("dE"), coffee_off, coffee_off.getEntryPoint("dE"), g4, new Action4()));
		Guard g5 = new Guard(new Guard5());
		putTransition(new Transition(sim, "offToIdle", coffee_off, coffee_off.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g5, new Action5()));
		Guard g6 = new Guard(new Guard6());
		putTransition(new Transition(sim, "offToOff1", coffee_off, coffee_off.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g6, new Action6()));
		Guard g7 = new Guard(new Guard7());
		putTransition(new Transition(sim, "offToOff2", coffee_off, coffee_off.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g7, new Action7()));
		Guard g8 = new Guard(new Guard8());
		putTransition(new Transition(sim, "offToOff3", coffee_off, coffee_off.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g8, new Action8()));
		Guard g9 = new Guard(new Guard9());
		putTransition(new Transition(sim, "offToOff4", coffee_off, coffee_off.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g9, new Action9()));
		Guard g10 = new Guard(new Guard10());
		putTransition(new Transition(sim, "idleToIdle1", idle, idle.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g10, new Action10()));
		Guard g11 = new Guard(new Guard11());
		putTransition(new Transition(sim, "idleToOff", idle, idle.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g11, new Action11()));
		Guard g12 = new Guard(new Guard12());
		putTransition(new Transition(sim, "idleToIdle2", idle, idle.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g12, new Action12()));
		Guard g13 = new Guard(new Guard13());
		putTransition(new Transition(sim, "idleToIdle3", idle, idle.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g13, new Action13()));
		Guard g14 = new Guard(new Guard14());
		putTransition(new Transition(sim, "idleToBusy", idle, idle.getExitPoint("dX"), busy, busy.getEntryPoint("dE"), g14, new Action14()));
		Guard g15 = new Guard(new Guard15());
		putTransition(new Transition(sim, "idleToIdle4", idle, idle.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g15, new Action15()));
		Guard g16 = new Guard(new Guard16());
		putTransition(new Transition(sim, "busyToBusy1", busy, busy.getExitPoint("dX"), busy, busy.getEntryPoint("dE"), g16, new Action16()));
		Guard g17 = new Guard(new Guard17());
		putTransition(new Transition(sim, "busyToOff", busy, busy.getExitPoint("dX"), coffee_off, coffee_off.getEntryPoint("dE"), g17, new Action17()));
		Guard g18 = new Guard(new Guard18());
		putTransition(new Transition(sim, "busyToBusy2", busy, busy.getExitPoint("dX"), busy, busy.getEntryPoint("dE"), g18, new Action18()));
		Guard g19 = new Guard(new Guard19());
		putTransition(new Transition(sim, "busyToBusy3", busy, busy.getExitPoint("dX"), busy, busy.getEntryPoint("dE"), g19, new Action19()));
		Guard g20 = new Guard(new Guard20());
		putTransition(new Transition(sim, "busyToIdle", busy, busy.getExitPoint("dX"), idle, idle.getEntryPoint("dE"), g20, new Action20()));
	}


	public class Guard0 extends BoolExpr {
	  public Guard0() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action0 extends Action {
	  public Action0() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard1 extends BoolExpr {
	  public Guard1() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action1 extends Action {
	  public Action1() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard2 extends BoolExpr {
	  public Guard2() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action2 extends Action {
	  public Action2() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard3 extends BoolExpr {
	  public Guard3() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action3 extends Action {
	  public Action3() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard4 extends BoolExpr {
	  public Guard4() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action4 extends Action {
	  public Action4() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard5 extends BoolExpr {
	  public Guard5() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action5 extends Action {
	  public Action5() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard6 extends BoolExpr {
	  public Guard6() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action6 extends Action {
	  public Action6() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard7 extends BoolExpr {
	  public Guard7() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action7 extends Action {
	  public Action7() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard8 extends BoolExpr {
	  public Guard8() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action8 extends Action {
	  public Action8() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard9 extends BoolExpr {
	  public Guard9() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action9 extends Action {
	  public Action9() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard10 extends BoolExpr {
	  public Guard10() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action10 extends Action {
	  public Action10() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard11 extends BoolExpr {
	  public Guard11() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action11 extends Action {
	  public Action11() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard12 extends BoolExpr {
	  public Guard12() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action12 extends Action {
	  public Action12() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard13 extends BoolExpr {
	  public Guard13() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue() == 0 && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action13 extends Action {
	  public Action13() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard14 extends BoolExpr {
	  public Guard14() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue() > 0 && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action14 extends Action {
	  public Action14() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(true);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard15 extends BoolExpr {
	  public Guard15() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action15 extends Action {
	  public Action15() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard16 extends BoolExpr {
	  public Guard16() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action16 extends Action {
	  public Action16() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard17 extends BoolExpr {
	  public Guard17() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action17 extends Action {
	  public Action17() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard18 extends BoolExpr {
	  public Guard18() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action18 extends Action {
	  public Action18() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard19 extends BoolExpr {
	  public Guard19() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action19 extends Action {
	  public Action19() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

	public class Guard20 extends BoolExpr {
	  public Guard20() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 2 ;
	  }
	}

	public class Action20 extends Action {
	  public Action20() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(1);
	  }
	}

}  // end of class Coffee
