
package CHARON.simulator.modes;
import CHARON.simulator.classes.*;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import  CHARON.user.*;

public class Environment extends Mode {
	Mode ready;
	Mode done;
	Mode inc;
	Mode coffee;
	Mode off;
	Mode on;

	public Environment(Simulation sim) {
	  super(sim);
	}

	public Environment() {
	  this(null);
	}
	public Environment(String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		this(null, nameOfThisMode, parameterOfThisMode, analogVarOfThisMode, discreteVarOfThisMode, vectorOfAssertions, parentOfThisMode, referredAgentOfThisMode); // tanli
	  }
	public Environment(Simulation sim, String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		super(sim);
		setModeName(nameOfThisMode);
		setInitSubModeName("ready");
		setParentMode(parentOfThisMode);
		referredAgent = referredAgentOfThisMode;
		pathname = getPathName();
		setDiscreteVars(discreteVarOfThisMode);
		setAnalogVars(analogVarOfThisMode);
		setAssertions(vectorOfAssertions);
		putEntryPoint(new EntryPoint("dE"));
		putExitPoint(new ExitPoint("dX"));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron")));

		/* Parameters */

		/* invariant, diff/alge equation */

		/* Submodes */
		ready = new empty(sim, "ready", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(ready);

		done = new empty(sim, "done", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(done);

		inc = new empty(sim, "inc", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(inc);

		coffee = new empty(sim, "coffee", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(coffee);

		off = new empty(sim, "off", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(off);

		on = new empty(sim, "on", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(on);


		/* Transitions */
		Guard g21 = new Guard(new Guard21());
		putTransition(new Transition(sim, "init1", this, this.getEntryPoint("dE"), ready, ready.getEntryPoint("dE"), g21, new Action21()));
		Guard g22 = new Guard(new Guard22());
		putTransition(new Transition(sim, "firePoweron", ready, ready.getExitPoint("dX"), on, on.getEntryPoint("dE"), g22, new Action22()));
		Guard g23 = new Guard(new Guard23());
		putTransition(new Transition(sim, "firePoweroff", ready, ready.getExitPoint("dX"), off, off.getEntryPoint("dE"), g23, new Action23()));
		Guard g24 = new Guard(new Guard24());
		putTransition(new Transition(sim, "fireInc", ready, ready.getExitPoint("dX"), inc, inc.getEntryPoint("dE"), g24, new Action24()));
		Guard g25 = new Guard(new Guard25());
		putTransition(new Transition(sim, "fireCoffee", ready, ready.getExitPoint("dX"), coffee, coffee.getEntryPoint("dE"), g25, new Action25()));
		Guard g26 = new Guard(new Guard26());
		putTransition(new Transition(sim, "fireDone", ready, ready.getExitPoint("dX"), done, done.getEntryPoint("dE"), g26, new Action26()));
		Guard g27 = new Guard(new Guard27());
		putTransition(new Transition(sim, "getAcksOn", on, on.getExitPoint("dX"), ready, ready.getEntryPoint("dE"), g27, new Action27()));
		Guard g28 = new Guard(new Guard28());
		putTransition(new Transition(sim, "getAcksOff", off, off.getExitPoint("dX"), ready, ready.getEntryPoint("dE"), g28, new Action28()));
		Guard g29 = new Guard(new Guard29());
		putTransition(new Transition(sim, "getAcksInc", inc, inc.getExitPoint("dX"), ready, ready.getEntryPoint("dE"), g29, new Action29()));
		Guard g30 = new Guard(new Guard30());
		putTransition(new Transition(sim, "getAcksCoffee", coffee, coffee.getExitPoint("dX"), ready, ready.getEntryPoint("dE"), g30, new Action30()));
		Guard g31 = new Guard(new Guard31());
		putTransition(new Transition(sim, "getAcksDone", done, done.getExitPoint("dX"), ready, ready.getEntryPoint("dE"), g31, new Action31()));
	}


	public class Guard21 extends BoolExpr {
	  public Guard21() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action21 extends Action {
	  public Action21() {}
	  public void action() {
	  }
	}

	public class Guard22 extends BoolExpr {
	  public Guard22() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action22 extends Action {
	  public Action22() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(2);
	  }
	}

	public class Guard23 extends BoolExpr {
	  public Guard23() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action23 extends Action {
	  public Action23() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(2);
	  }
	}

	public class Guard24 extends BoolExpr {
	  public Guard24() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action24 extends Action {
	  public Action24() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(2);
	  }
	}

	public class Guard25 extends BoolExpr {
	  public Guard25() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action25 extends Action {
	  public Action25() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(2);
	  }
	}

	public class Guard26 extends BoolExpr {
	  public Guard26() {}
	  public boolean guard() {
	    return true ;
	  }
	}

	public class Action26 extends Action {
	  public Action26() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(2);
	  }
	}

	public class Guard27 extends BoolExpr {
	  public Guard27() {}
	  public boolean guard() {
	    return ( ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).getValue() == true ) ;
	  }
	}

	public class Action27 extends Action {
	  public Action27() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_on"), "Discrete")+renaming(referredAgent, "ack_coffee_on"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard28 extends BoolExpr {
	  public Guard28() {}
	  public boolean guard() {
	    return ( ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).getValue() == true ) ;
	  }
	}

	public class Action28 extends Action {
	  public Action28() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_off"), "Discrete")+renaming(referredAgent, "ack_coffee_off"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard29 extends BoolExpr {
	  public Guard29() {}
	  public boolean guard() {
	    return ( ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).getValue() == true ) ;
	  }
	}

	public class Action29 extends Action {
	  public Action29() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_inc"), "Discrete")+renaming(referredAgent, "ack_coffee_inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard30 extends BoolExpr {
	  public Guard30() {}
	  public boolean guard() {
	    return ( ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).getValue() == true ) ;
	  }
	}

	public class Action30 extends Action {
	  public Action30() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_coffee"), "Discrete")+renaming(referredAgent, "ack_coffee_coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard31 extends BoolExpr {
	  public Guard31() {}
	  public boolean guard() {
	    return ( ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).getValue() == true ) ;
	  }
	}

	public class Action31 extends Action {
	  public Action31() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_coffee_done"), "Discrete")+renaming(referredAgent, "ack_coffee_done"))).updateValue(false);
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

}  // end of class Environment
