
package CHARON.simulator.modes;
import CHARON.simulator.classes.*;
import CHARON.simulator.*;
import CHARON.gui.manager.*;
import CHARON.simulator.modes.*;
import CHARON.simulator.agents.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import  CHARON.user.*;

public class Money extends Mode {
	Mode nomoney;
	Mode money_off;
	Mode havemoney;

	public Money(Simulation sim) {
	  super(sim);
	}

	public Money() {
	  this(null);
	}
	public Money(String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		this(null, nameOfThisMode, parameterOfThisMode, analogVarOfThisMode, discreteVarOfThisMode, vectorOfAssertions, parentOfThisMode, referredAgentOfThisMode); // tanli
	  }
	public Money(Simulation sim, String nameOfThisMode, Vector parameterOfThisMode, Vector analogVarOfThisMode, Vector discreteVarOfThisMode, Vector vectorOfAssertions, Mode parentOfThisMode, Agent referredAgentOfThisMode) {
		super(sim);
		setModeName(nameOfThisMode);
		setInitSubModeName("nomoney");
		setParentMode(parentOfThisMode);
		referredAgent = referredAgentOfThisMode;
		pathname = getPathName();
		setDiscreteVars(discreteVarOfThisMode);
		setAnalogVars(analogVarOfThisMode);
		setAssertions(vectorOfAssertions);
		putEntryPoint(new EntryPoint("dE"));
		putExitPoint(new ExitPoint("dX"));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff")));
		putReadVar(getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on")));
		putReadWriteVar(getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec")));

		/* Parameters */

		/* invariant, diff/alge equation */

		/* Submodes */
		nomoney = new empty(sim, "nomoney", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(nomoney);

		money_off = new empty(sim, "money_off", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(money_off);

		havemoney = new empty(sim, "havemoney", getParams(), getAnalogVars(), getDiscreteVars(), getAssertions(), this, this.referredAgent);
		putSubMode(havemoney);


		/* Transitions */
		Guard g32 = new Guard(new Guard32());
		putTransition(new Transition(sim, "defToNomoney", this, this.getEntryPoint("dE"), nomoney, nomoney.getEntryPoint("dE"), g32, new Action32()));
		Guard g33 = new Guard(new Guard33());
		putTransition(new Transition(sim, "defToOff1", this, this.getEntryPoint("dE"), money_off, money_off.getEntryPoint("dE"), g33, new Action33()));
		Guard g34 = new Guard(new Guard34());
		putTransition(new Transition(sim, "defToOff2", this, this.getEntryPoint("dE"), money_off, money_off.getEntryPoint("dE"), g34, new Action34()));
		Guard g35 = new Guard(new Guard35());
		putTransition(new Transition(sim, "defToOff3", this, this.getEntryPoint("dE"), money_off, money_off.getEntryPoint("dE"), g35, new Action35()));
		Guard g36 = new Guard(new Guard36());
		putTransition(new Transition(sim, "defToOff4", this, this.getEntryPoint("dE"), money_off, money_off.getEntryPoint("dE"), g36, new Action36()));
		Guard g37 = new Guard(new Guard37());
		putTransition(new Transition(sim, "offToNomoney", money_off, money_off.getExitPoint("dX"), nomoney, nomoney.getEntryPoint("dE"), g37, new Action37()));
		Guard g38 = new Guard(new Guard38());
		putTransition(new Transition(sim, "offToOff1", money_off, money_off.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g38, new Action38()));
		Guard g39 = new Guard(new Guard39());
		putTransition(new Transition(sim, "offToOff2", money_off, money_off.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g39, new Action39()));
		Guard g40 = new Guard(new Guard40());
		putTransition(new Transition(sim, "offToOff3", money_off, money_off.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g40, new Action40()));
		Guard g41 = new Guard(new Guard41());
		putTransition(new Transition(sim, "offToOff4", money_off, money_off.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g41, new Action41()));
		Guard g42 = new Guard(new Guard42());
		putTransition(new Transition(sim, "nomoneyToNomoney1", nomoney, nomoney.getExitPoint("dX"), nomoney, nomoney.getEntryPoint("dE"), g42, new Action42()));
		Guard g43 = new Guard(new Guard43());
		putTransition(new Transition(sim, "nomoneyToOff", nomoney, nomoney.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g43, new Action43()));
		Guard g44 = new Guard(new Guard44());
		putTransition(new Transition(sim, "nomoneyToHavemoney", nomoney, nomoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g44, new Action44()));
		Guard g45 = new Guard(new Guard45());
		putTransition(new Transition(sim, "nomoneyToNomoney2", nomoney, nomoney.getExitPoint("dX"), nomoney, nomoney.getEntryPoint("dE"), g45, new Action45()));
		Guard g46 = new Guard(new Guard46());
		putTransition(new Transition(sim, "nomoneyToNomoney3", nomoney, nomoney.getExitPoint("dX"), nomoney, nomoney.getEntryPoint("dE"), g46, new Action46()));
		Guard g47 = new Guard(new Guard47());
		putTransition(new Transition(sim, "havemoneyToHavemoney1", havemoney, havemoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g47, new Action47()));
		Guard g48 = new Guard(new Guard48());
		putTransition(new Transition(sim, "havemoneyToOff", havemoney, havemoney.getExitPoint("dX"), money_off, money_off.getEntryPoint("dE"), g48, new Action48()));
		Guard g49 = new Guard(new Guard49());
		putTransition(new Transition(sim, "havemoneyToHavemoney2", havemoney, havemoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g49, new Action49()));
		Guard g50 = new Guard(new Guard50());
		putTransition(new Transition(sim, "havemoneyToHavemoney3", havemoney, havemoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g50, new Action50()));
		Guard g51 = new Guard(new Guard51());
		putTransition(new Transition(sim, "havemoneyToHavemoney4", havemoney, havemoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g51, new Action51()));
		Guard g52 = new Guard(new Guard52());
		putTransition(new Transition(sim, "havemoneyToHavemoney5", havemoney, havemoney.getExitPoint("dX"), havemoney, havemoney.getEntryPoint("dE"), g52, new Action52()));
		Guard g53 = new Guard(new Guard53());
		putTransition(new Transition(sim, "havemoneyToNomoney", havemoney, havemoney.getExitPoint("dX"), nomoney, nomoney.getEntryPoint("dE"), g53, new Action53()));
	}


	public class Guard32 extends BoolExpr {
	  public Guard32() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action32 extends Action {
	  public Action32() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard33 extends BoolExpr {
	  public Guard33() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action33 extends Action {
	  public Action33() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard34 extends BoolExpr {
	  public Guard34() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action34 extends Action {
	  public Action34() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard35 extends BoolExpr {
	  public Guard35() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action35 extends Action {
	  public Action35() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard36 extends BoolExpr {
	  public Guard36() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action36 extends Action {
	  public Action36() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard37 extends BoolExpr {
	  public Guard37() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action37 extends Action {
	  public Action37() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard38 extends BoolExpr {
	  public Guard38() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action38 extends Action {
	  public Action38() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard39 extends BoolExpr {
	  public Guard39() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action39 extends Action {
	  public Action39() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard40 extends BoolExpr {
	  public Guard40() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action40 extends Action {
	  public Action40() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard41 extends BoolExpr {
	  public Guard41() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action41 extends Action {
	  public Action41() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard42 extends BoolExpr {
	  public Guard42() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action42 extends Action {
	  public Action42() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard43 extends BoolExpr {
	  public Guard43() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action43 extends Action {
	  public Action43() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard44 extends BoolExpr {
	  public Guard44() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action44 extends Action {
	  public Action44() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).updateValue(1);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard45 extends BoolExpr {
	  public Guard45() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action45 extends Action {
	  public Action45() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard46 extends BoolExpr {
	  public Guard46() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action46 extends Action {
	  public Action46() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard47 extends BoolExpr {
	  public Guard47() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweron"), "Discrete")+renaming(referredAgent, "poweron"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action47 extends Action {
	  public Action47() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_on"), "Discrete")+renaming(referredAgent, "ack_money_on"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard48 extends BoolExpr {
	  public Guard48() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "poweroff"), "Discrete")+renaming(referredAgent, "poweroff"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action48 extends Action {
	  public Action48() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_off"), "Discrete")+renaming(referredAgent, "ack_money_off"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard49 extends BoolExpr {
	  public Guard49() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "inc"), "Discrete")+renaming(referredAgent, "inc"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue() < 10 && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action49 extends Action {
	  public Action49() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_inc"), "Discrete")+renaming(referredAgent, "ack_money_inc"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).updateValue(((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue()+1);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard50 extends BoolExpr {
	  public Guard50() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).getValue() == false && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action50 extends Action {
	  public Action50() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_coffee"), "Discrete")+renaming(referredAgent, "ack_money_coffee"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard51 extends BoolExpr {
	  public Guard51() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "done"), "Discrete")+renaming(referredAgent, "done"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action51 extends Action {
	  public Action51() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "ack_money_done"), "Discrete")+renaming(referredAgent, "ack_money_done"))).updateValue(true);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).updateValue(0);
	  }
	}

	public class Guard52 extends BoolExpr {
	  public Guard52() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue() > 1 && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action52 extends Action {
	  public Action52() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).updateValue(((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue()-1);
	  }
	}

	public class Guard53 extends BoolExpr {
	  public Guard53() {}
	  public boolean guard() {
	    return ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "coffee"), "Discrete")+renaming(referredAgent, "coffee"))).getValue() == true && ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).getValue() == true && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).getValue() == 1 && ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "priority"), "Discrete")+renaming(referredAgent, "priority"))).getValue() == 1 ;
	  }
	}

	public class Action53 extends Action {
	  public Action53() {}
	  public void action() {
	  ((Bool)getDiscreteVar(getPathName(renaming(referredAgent, "dec"), "Discrete")+renaming(referredAgent, "dec"))).updateValue(false);
	  ((Int)getDiscreteVar(getPathName(renaming(referredAgent, "m"), "Discrete")+renaming(referredAgent, "m"))).updateValue(0);
	  }
	}

}  // end of class Money
